import { GeneralService } from '../share/generalservice.js'

export class AccountingSumService {
  constructor() {
    this.generalService = new GeneralService()
  }
  async getAccountingSum(database, id) {
    const sql = `
      SELECT 
        actseq,
        actnum,
        acttyp,
        ${database}.translatedtl('ACTTYP', acttyp) as acttypnam,
        ${database}.translatedtl_multi(ARRAY['ACTCAT_INC', 'ACTCAT_EXP'], actcat) as actcatnam,
        actqty,
        actcmt,
        actacpdtm
      FROM ${database}.actmst
      WHERE actnum = $1
      `
    const params = [id]
    const result = await this.generalService.executeQueryParam(database, sql, params);
    return result
  }

    async getCategoryColorMap(database) {
    const sql = `
        SELECT dtlcod, dtlnam, dtlmsc as dtlclr
        FROM ${database}.dtlmst
        WHERE dtltblcod IN ('ACTCAT_INC', 'ACTCAT_EXP')
    `;
    const params = []
    const rows = await this.generalService.executeQueryParam(database, sql, params);

    const map = {};
    rows.forEach(r => {
        map[r.dtlnam] = r.dtlclr;    // ใช้ชื่อหมวดเป็น key
    });

    return map;
  }

}